# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from mtmai.clients.rest.models.social_team_config import SocialTeamConfig
from typing import Optional, Set
from typing_extensions import Self

class SocialTeamComponent(BaseModel):
    """
    SocialTeamComponent
    """ # noqa: E501
    provider: StrictStr
    component_type: StrictStr
    version: Optional[StrictInt] = None
    component_version: Optional[StrictInt] = None
    description: Optional[StrictStr] = None
    label: Optional[StrictStr] = None
    config: SocialTeamConfig
    __properties: ClassVar[List[str]] = ["provider", "component_type", "version", "component_version", "description", "label", "config"]

    @field_validator('provider')
    def provider_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['mtmai.teams.team_social.SocialTeam']):
            raise ValueError("must be one of enum values ('mtmai.teams.team_social.SocialTeam')")
        return value

    @field_validator('component_type')
    def component_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['team']):
            raise ValueError("must be one of enum values ('team')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SocialTeamComponent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SocialTeamComponent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in SocialTeamComponent) in the input: " + _key)

        _obj = cls.model_validate({
            "provider": obj.get("provider"),
            "component_type": obj.get("component_type") if obj.get("component_type") is not None else 'team',
            "version": obj.get("version"),
            "component_version": obj.get("component_version"),
            "description": obj.get("description"),
            "label": obj.get("label"),
            "config": SocialTeamConfig.from_dict(obj["config"]) if obj.get("config") is not None else None
        })
        return _obj


