# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from mtmai.clients.rest.models.ag_events import AgEvents
from typing import Optional, Set
from typing_extensions import Self

class SocialTeamManagerState(BaseModel):
    """
    SocialTeamManagerState
    """ # noqa: E501
    type: StrictStr
    version: Optional[StrictStr] = None
    next_speaker_index: Optional[StrictInt] = 0
    previous_speaker: Optional[StrictStr] = None
    current_speaker: Optional[StrictStr] = None
    selector_prompt: Optional[StrictStr] = None
    allow_repeated_speaker: Optional[StrictBool] = None
    max_selector_attempts: Optional[StrictInt] = None
    selector_func: Optional[StrictStr] = None
    current_turn: Optional[StrictInt] = 0
    message_thread: Optional[List[AgEvents]] = None
    __properties: ClassVar[List[str]] = ["type", "version", "next_speaker_index", "previous_speaker", "current_speaker", "selector_prompt", "allow_repeated_speaker", "max_selector_attempts", "selector_func", "current_turn", "message_thread"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['SocialTeamManagerState']):
            raise ValueError("must be one of enum values ('SocialTeamManagerState')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SocialTeamManagerState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in message_thread (list)
        _items = []
        if self.message_thread:
            for _item_message_thread in self.message_thread:
                if _item_message_thread:
                    _items.append(_item_message_thread.to_dict())
            _dict['message_thread'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SocialTeamManagerState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in SocialTeamManagerState) in the input: " + _key)

        _obj = cls.model_validate({
            "type": obj.get("type") if obj.get("type") is not None else 'SocialTeamManagerState',
            "version": obj.get("version"),
            "next_speaker_index": obj.get("next_speaker_index") if obj.get("next_speaker_index") is not None else 0,
            "previous_speaker": obj.get("previous_speaker"),
            "current_speaker": obj.get("current_speaker"),
            "selector_prompt": obj.get("selector_prompt"),
            "allow_repeated_speaker": obj.get("allow_repeated_speaker"),
            "max_selector_attempts": obj.get("max_selector_attempts"),
            "selector_func": obj.get("selector_func"),
            "current_turn": obj.get("current_turn") if obj.get("current_turn") is not None else 0,
            "message_thread": [AgEvents.from_dict(_item) for _item in obj["message_thread"]] if obj.get("message_thread") is not None else None
        })
        return _obj


