# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from mtmai.clients.rest.models.schema_form import SchemaForm
from typing import Optional, Set
from typing_extensions import Self

class UserAgentState(BaseModel):
    """
    UserAgentState
    """ # noqa: E501
    type: Optional[StrictStr] = None
    model_context: Optional[Any] = None
    action_form: Optional[SchemaForm] = None
    platform_account_id: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["type", "model_context", "action_form", "platform_account_id"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['UserAgentState']):
            raise ValueError("must be one of enum values ('UserAgentState')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserAgentState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of action_form
        if self.action_form:
            _dict['action_form'] = self.action_form.to_dict()
        # set to None if model_context (nullable) is None
        # and model_fields_set contains the field
        if self.model_context is None and "model_context" in self.model_fields_set:
            _dict['model_context'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserAgentState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in UserAgentState) in the input: " + _key)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "model_context": obj.get("model_context"),
            "action_form": SchemaForm.from_dict(obj["action_form"]) if obj.get("action_form") is not None else None,
            "platform_account_id": obj.get("platform_account_id")
        })
        return _obj


